/**
 ** A Virtual Host Monitor
 **
 ** Copyright 2009 Gary Wuertz gary@issiweb.com
 **
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef TOPVHOST_CONFIG_H
#define TOPVHOST_CONFIG_H

#include <map>
#include <string>
/**
 * A simple configuration class
 */
class Config
{
public:
   Config(char const* path = "");
   std::string cntrl(std::string s);                                 // implement control char
   void dump(void);                                                  // dump content
   std::string filename(void);                                       // get app config filename
   std::string get(char const* name);                                // from current section
   std::map<std::string,std::string>* getSection(char const* name);  // get all settings in section
   void load(char const* section);                                   // choose the section
   void set(char const* name, char const* value);                    // to current section
private:
   std::map<std::string,std::string> content;                        // The settings
   std::string             section;                                  // loaded section

   void        read(std::string const& configFile);
   std::string trim(std::string const& source, char const* delims  = " \t\r\n");
};
#endif
